# -*- encoding: utf-8 -*-
# stub: twitterpunch 0.0.9 ruby lib

Gem::Specification.new do |s|
  s.name = "twitterpunch".freeze
  s.version = "0.0.9"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib".freeze]
  s.authors = ["Ben Ford".freeze]
  s.date = "2017-10-19"
  s.description = "Twitterpunch\n===============\n\nTwitterpunch is designed to work with PhotoBooth and OS X Folder Actions.\nWhen this script is called with the name of an image file, it will post the\nimage to Twitter, along with a message randomly chosen from a list and a\nspecified hashtag.\n\nIf you call the script with the `--stream` argument instead, it will listen\nfor tweets to that hashtag and download them to a specified directory. If\nthe tweet came from another user, Twitterpunch will speak it aloud.\n\nTypically, you'll run one copy on an OSX laptop with PhotoBooth, and a separate\ncopy on another machine (either Windows or OSX) for the viewer. You can also use\na mobile device as a remote control, if you like. This will allow the user to\nenter a custom message for each photo that gets tweeted out, if they'd like.\n\n\nConfiguration\n===========\n\nConfigure the program via the `~/.twitterpunch/config.yaml` YAML file. This file\nshould look similar to the example below.\n\n    ---\n    :twitter:                               # twitter configuration\n      :consumer_key: <consumer key>\n      :consumer_secret: <consumer secret>\n      :access_token: <access token>\n      :access_token_secret: <access secret>\n    :messages:                              # list of messages to attach\n    - Hello there                           # to outgoing tweets\n    - I'm a posting fool\n    - minimally viable product\n    :hashtag: Twitterpunch                  # The hashtag to post and listen to\n    :handle: Twitterpunch                   # The twitter username to post as\n    :photodir: ~/Pictures/twitterpunch/     # Where to save downloaded images\n    :logfile: ~/.twitterpunch/activity.log  # Where to save logs\n    :viewer:                                # Use the built-in slideshow viewer\n      :count: 5                             # How many images to have onscreen at once\n    :remote:\n      :timeout: 45                          # How long the button should remain disabled for\n      :apptitle: dslrBooth                  # The photo booth application title\n      :hotkey: space                        # Which hotkey to send to trigger a photo\n\n1. Generate a skeleton configuration file\n    * `twitterpunch --configure`\n1. Edit the configuration file as needed. You'll be prompted with the path.\n    * If you have your own Twitter application credentials, you're welcome to use them.\n1. Authorize the application with the Twitter API.\n    * `twitterpunch --authorize`\n\n\nUsage \n==========\n\n### Using OS X PhotoBooth\n\n1. Start PhotoBooth at least once to generate its library.\n1. Install the Twitterpunch Folder Action\n    * `twitterpunch --install`\n    * It may claim that it could not be attached, fear not.\n1. Profit!\n    * _and by that, I mean take some shots with PhotoBooth!_\n\n*Note*: if the folder action doesn't seem to work and photos aren't posted to\nTwitter, here are some troubleshooting steps to take:\n\n1. Run Twitterpunch by hand with photos as arguments. This may help you isolate\n   configuration or authorization issues.\n    * `twitterpunch foo.jpg`\n1. Correct the path in the workflow.\n    * `which twitterpunch`\n    * Edit the Twitterpunch folder action to include that path.\n\n#### Using the remote web app\n\nConfigure the remote web app using the `:remote` hash in `config.yaml`. You can\nusually find the title of the app using `system_profiler -detailLevel full SPApplicationsDataType`\nand grepping for the name or path to the `.app`.\n\nIn this example, the title is _dslrBooth_.\n\n    [ben@ganymede] ~ $ system_profiler -detailLevel full SPApplicationsDataType | grep -B8 dslrBooth.app\n        dslrBooth:\n\n          Version: 2.9\n          Obtained from: Identified Developer\n          Last Modified: 10/14/17, 9:50 PM\n          Kind: Intel\n          64-Bit (Intel): Yes\n          Signed by: Developer ID Application: Hope Pictures LLC (MZR5GHAQX4), Developer ID Certification Authority, Apple Root CA\n          Location: /Applications/dslrBooth.app\n\n1. Run the app with `twitterpunch --remote`\n1. Browse to the app with http://{address}:8080\n1. [optional] If on an iOS device, add to your homescreen\n    * This will give you \"app behaviour\", such as full screen, and a nice icon\n\n\n#### Troubleshooting.\n\n1. Make sure the folder action is installed properly\n    1. Use the Finder to navigate to `~/Pictures/`\n    1. Right click on the `Photo Booth Library` icon and choose _Show Package Contents_.\n    1. Right click on the `Pictures` folder and choose `Services > Folder Actions Setup`\n    1. Make sure that the `Twitterpunch` action is attached.\n1. Install the folder action\n    1. Open the `resources` folder of this gem.\n        * Likely to be found in `/Library/Ruby/Gems/{version}/gems/twitterpunch-\#{version}/resources/`.\n    1. Double click on the `Twitterpunch` folder action and install it.\n        * It may claim that it could not be attached, fear not.\n\n\n### Using something besides PhotoBooth\n\nConfigure the program you are using for your photo shoot to call Twitterpunch\neach time it snaps a photo. Pass the name of the new photo as a command line\nargument.  Alternatively, you could batch them, as Twitterpunch can accept\nmultiple files at once.\n\n    [ben@ganymede] ~ $ twitterpunch photo.jpg [photo2.jpg photo3.jpg photo4.jpg]\n\nYou can manually install the Folder Action, or you can follow the automated\ninstall process after tweaking the workflow slightly.\n\n1. Identify where the app stores the resulting image files.\n1. Edit the Twitterpunch folder action to include that path.\n1. Follow the steps above to install the Folder Action.\n\n### Viewing the Twitter stream\n\nTwitterpunch will run on OS X or Windows equally well. Simply configure it on the\ncomputer that will act as the Twitter display and then run in streaming mode.\n\n    [ben@ganymede] ~ $ twitterpunch --stream\n\nThere are two modes that Twitterpunch can operate in.\n\n1. If a `:hashtag` is defined then all images tweeted to the configured hashtag\n   will be displayed in the slideshow.\n1. Otherwise, Twitterpunch will stream the `:handle` Twitter user's stream and\n   display all images either posted by that user or addressed to that user. With\n   protected tweets, you can have rudimentary access control.\n\nIn either mode, tweets that come from any other user will also be spoken aloud.\n\nIf you don't want to use the built-in slideshow viewer, you can disable it by\nremoving the `:viewer` key from your `~/.twitterpunch/config.yaml` config file.\nTwitterpunch will then simply download the tweeted images and save them into the\n`:photodir` directory. You can then use anything you like to view them.\n\nThere are currently two decent viewing options I am aware of.\n\n* Windows background image:\n    * Configure the Windows background to randomly cycle through photos in a directory.\n    * Hide desktop icons.\n    * Hide the taskbar.\n    * Disable screensaver and power savings.\n    * Drawbacks: You're using Windows and you have to install Ruby & RubyGems manually.\n* OS X screensaver:\n    * Choose one of the sexy screensavers and configure it to show photos from the `:photodir`\n    * Set screensaver to a super short timeout.\n    * Disable power savings.\n    * Drawbacks: The screensaver doesn't reload dynamically, so I have to kick it\n      and you'll see it reloading each time a new tweet comes in.\n\n\nLimitations\n===========\n\n* It currently requires manual setup for Folder Actions.\n* Rubygame is kind of a pain to set up.\n\n\nContact\n=======\n\n* Author: Ben Ford\n* Email: binford2k@gmail.com\n* Twitter: @binford2k\n* IRC (Freenode): binford2k\n".freeze
  s.email = "binford2k@gmail.com".freeze
  s.executables = ["twitterpunch".freeze]
  s.files = ["bin/twitterpunch".freeze]
  s.homepage = "https://github.com/binford2k/twitterpunch".freeze
  s.licenses = ["MIT".freeze]
  s.post_install_message = "\n  ************************************************************************\n  Be aware that RubyGame is BROKEN on OSX right now. You will need this\n  patch before Twitterpunch will work properly:\n\n  https://github.com/xrs1133/ruby-sdl-ffi/commit/0b721ac4659b4c08cda5aa2f418561a8a311e85b\n\n  ************************************************************************\n\n".freeze
  s.rubygems_version = "3.2.22".freeze
  s.summary = "A simple tool to automate the posting and streaming of PhotoBooth shots over Twitter.".freeze

  s.installed_by_version = "3.2.22" if s.respond_to? :installed_by_version

  if s.respond_to? :specification_version then
    s.specification_version = 4
  end

  if s.respond_to? :add_runtime_dependency then
    s.add_runtime_dependency(%q<twitter>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<oauth>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<colorize>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<rubygame>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<sinatra>.freeze, [">= 0"])
    s.add_runtime_dependency(%q<rmagick>.freeze, [">= 0"])
  else
    s.add_dependency(%q<twitter>.freeze, [">= 0"])
    s.add_dependency(%q<oauth>.freeze, [">= 0"])
    s.add_dependency(%q<colorize>.freeze, [">= 0"])
    s.add_dependency(%q<rubygame>.freeze, [">= 0"])
    s.add_dependency(%q<sinatra>.freeze, [">= 0"])
    s.add_dependency(%q<rmagick>.freeze, [">= 0"])
  end
end
